#define ARM
#include <Standalone.h>
#include <PalmOS.h>
#include <PceNativeCall.h>

#include "palmxqrsc.h"
#include "defs.h"
#include "data.h"
#include "protos.h"

STANDALONE_CODE_RESOURCE_ID( armThink );

#define SWAP32( x ) ( (UInt32)(x) << 24 | (UInt32)(x & 0xFF00) << 8 | (UInt32)( x & 0xFF0000 ) >> 8 | \
                      (UInt32)(x) >> 24 )
#define SWAP16( x ) ( (UInt16)(x) >> 8 | (UInt16)(x) << 8 )

static void SwapGlobals( ARMGLOBALS_PROTO_VOID );

UInt32 ARMThink( const void* emulStateP, void* userData68KP, Call68KFuncType* call68KFuncP )
{
    SwapGlobals( userData68KP );
    Think( userData68KP );
    SwapGlobals( userData68KP );
    return 0;
}

static void SwapArray16( Int16* p, UInt32 count )
{
    while( count-- ) {
        *p = SWAP16( *p );
        p++;
    }
}

static void SwapGlobals( ARMGLOBALS_PROTO_VOID )
{
    UInt32 i;

    Time     = SWAP32( Time );
    StopTime = SWAP32( StopTime );
    MaxTime  = SWAP32( MaxTime );
    Node     = SWAP32( Node );

    SwapArray16( PVLength, MAX_PLY );
    SwapArray16( FirstMove, MAX_PLY );
    Ply  = SWAP16( Ply );
    HPly = SWAP16( HPly );
    
    for ( i = 0 ; i < GEN_STACK ; i++ )
         GenDat[ i ].score = SWAP16( GenDat[ i ].score );
}

#include "search.c"
#include "board.c"
#include "gen.c"
#include "eval.c"

STUB_MemSet
STUB_TimGetSeconds
STUB_WinDrawChar
STUB_StrPrintF
STUB_StrLen
STUB_WinDrawChars
STUB_SysRandom
STUB_SysTaskDelay
STUB_SysTicksPerSecond
STUB_TimGetTicks
