/***********************************************************************
 *
 * PROJECT:  PalmXQ
 * FILE:     data.h
 * AUTHOR:   Cheok Yan Cheng
 *
 * DESCRIPTION: Prototypes of all global variables
 *
 * LAST REVISION:  24/02/2002
 *
 ***********************************************************************/

#ifndef _DATA_H
#define _DATA_H

#include "defs.h"

typedef struct GameGlobals_tag {
    /* 32 bit data */
    Int32  Time;
    Int32  StopTime;
    Int32  MaxTime;
    UInt32 Node;
    GenT  GenDat[GEN_STACK];
    HistT HistDat[HIST_STACK];

    /* 16 bit data */
    Int16 Ply;
    Int16 HPly;
    Int16 PVLength[MAX_PLY];
    MoveT PV[MAX_PLY][MAX_PLY];
    Int16 FirstMove[MAX_PLY+1];

    /* 8 bit data */
    UInt8 Color[BRD_SIZE + 1];
    UInt8 Piece[BRD_SIZE + 1];
    Int8 PointTable[7][90];
    UInt8 History[BRD_SIZE][BRD_SIZE];
    Char ListElements[HIST_STACK + 1][5];
    UInt8 Side;
    UInt8 XSide;
    UInt8 Fifty;
    UInt8 MaxDepth;
    Int8 Offset[7][8];
    Int8 Mailbox182[182];
    UInt8 Mailbox90[90];
    UInt8 LegalPosition[90];
    UInt8 MaskPiece[7];
    Int8 KnightCheck[8];
    Int8 ElephantCheck[8];
    Boolean IsFlip;
    Boolean FollowPV;
    UInt8 ComputerSide;
    UInt8 ComputerDepth;
    UInt8 KingPalaceDark[9];
    UInt8 KingPalaceLight[9];
    Boolean Terminate;
} GameGlobals;

extern GameGlobals Globals;

#include "GlobalDefines.h"

#endif
