/***********************************************************************
 *
 * PROJECT: PalmXQ
 * FILE:    levelform.c
 * AUTHOR:  Cheok Yan Cheng
 *
 * DESCRIPTION: Level form for PalmXQ.
 *
 * LAST REVISION:   24/02/2002
 *
 ***********************************************************************/

#include <PalmOS.h>
#include "palmxqrsc.h"
#include "data.h"
#include "protos.h"
#include "defs.h"

static Boolean LevelOnFrmOpen(EventPtr event);
static Boolean LevelOnCtlSelectEvent(FormType *form, UInt16 controlID);

static Boolean LevelOnFrmOpen(EventPtr event)
{
    Boolean  handled = false;
    Char szTime[4];
    FormType  *form;
    UInt16 buttonID;
    form = FrmGetActiveForm();

    FrmDrawForm(form);

    if(ComputerDepth == 3)
    {
        buttonID = LevelButton1;
    }
    else if(ComputerDepth == 4)
    {
        buttonID = LevelButton2;
    }
    else if(ComputerDepth == 5)
    {
        buttonID = LevelButton3;
    }
    else
    {
        buttonID = LevelButton4;
    }
    FrmSetControlGroupSelection(form, 1, buttonID);

    if(ComputerSide == EMPTY)
    {
        buttonID = ComputerButtonNone;
    }
    else if(ComputerSide == LIGHT)
    {
        buttonID = ComputerButtonLight;
    }
    else
    {
        buttonID = ComputerButtonDark;
    }
    FrmSetControlGroupSelection(form, 2, buttonID);

    StrIToA(szTime, MaxTime);
    SetFldText(form, LevelField, szTime );

    handled = true;

    return handled;
}

Boolean LevelHandleEvent(EventPtr event)
{
    Boolean  handled = false;
    FormType  *form;

    form = FrmGetActiveForm();

    switch (event->eType)
    {
        case frmOpenEvent:
            handled = LevelOnFrmOpen(event);
            break;

        case ctlSelectEvent:
            handled = LevelOnCtlSelectEvent(form, event->data.ctlSelect.controlID);

        default:
            break;
    }

    return handled;
}

static Boolean LevelOnCtlSelectEvent(FormType *form, UInt16 controlID)
{
    Boolean  handled = false;
    char *s;
    Int32 i;

    switch(controlID)
    {
        case LevelOK: {
            EventType event;

            s = FldGetTextPtr(FrmGetObjectPtr(form,
                                FrmGetObjectIndex(form, LevelField)));


            i = StrAToI(s);
            if(i < 1 || i > 999)
            {
                FrmAlert(FieldAlert);
                break;
            }
            else
            {
                MaxTime = i;
            }

            if(CtlGetValue(FrmGetObjectPtr(form,
                            FrmGetObjectIndex(form, LevelButton1))))
            {
                ComputerDepth = 3;
            }
            else if(CtlGetValue(FrmGetObjectPtr(form,
                            FrmGetObjectIndex(form, LevelButton2))))
            {
                ComputerDepth = 4;
            }
            else if(CtlGetValue(FrmGetObjectPtr(form,
                            FrmGetObjectIndex(form, LevelButton3))))
            {
                ComputerDepth = 5;
            }
            else
            {
                ComputerDepth = 6;
            }

            if(CtlGetValue(FrmGetObjectPtr(form,
                            FrmGetObjectIndex(form, ComputerButtonNone))))
            {
                ComputerSide = EMPTY;
            }
            else if(CtlGetValue(FrmGetObjectPtr(form,
                            FrmGetObjectIndex(form, ComputerButtonLight))))
            {
                ComputerSide = LIGHT;
            }
            else
            {
                ComputerSide = DARK;
            }

            FrmReturnToForm(0);
            
            MemSet( &event, sizeof( EventType ), 0 );
            event.eType = MOVE_EVENT;
            EvtAddEventToQueue( &event );

            handled = true;
            break;
        }

        case LevelCancel:
            FrmReturnToForm(0);
            handled = true;
            break;

        default:
            break;

    }

    return handled;
}

