/***********************************************************************
 *
 * PROJECT:  PalmXQ
 * FILE:     protos.h
 * AUTHOR:   Cheok Yan Cheng
 *
 * DESCRIPTION:  All function prototypes for PalmXQ.
 *
 * LAST REVISION:  24/02/2002
 *
 ***********************************************************************/

#ifndef _PROTOS_H
#define _PROTOS_H

#include "defs.h"

#ifdef ARM
# define ARMGLOBALS_PROTO      GameGlobals* g,
# define ARMGLOBALS_PROTO_VOID GameGlobals* g
# define ARMGLOBALS            g,
# define ARMGLOBALS_VOID       g
#else
# define ARMGLOBALS_PROTO
# define ARMGLOBALS_PROTO_VOID void
# define ARMGLOBALS
# define ARMGLOBALS_VOID
#endif

/* data.c */
extern void InitGlobals(void);

/* mainform.c */
extern Boolean MainHandleEvent(EventPtr event);

/* board.c */
extern void DrawBoard(FormType *form, UInt16 gadgetID,
                    UInt8 *piece, UInt8 *color, Boolean isFlip);

extern Boolean ScrnToBrdCoord(FormType *form, UInt16 gadgetID,
                            Int16 scrnX, Int16 scrnY, Boolean isFlip,
                            Int16 *location);

extern Boolean DrawPieceBound(FormType *form, UInt16 gadgetID,
                            Int16 location, Boolean isFlip);
extern void InitBoard(void);
extern void SetupGame(void);
extern void BrdCoordToWXF(Int16 from, Int16 to, Char *wxf);
extern Boolean MakeMove(ARMGLOBALS_PROTO MoveT move);
extern void UnMakeMove(ARMGLOBALS_PROTO_VOID);
extern void MakeNullMove(ARMGLOBALS_PROTO_VOID);
extern void UnMakeNullMove(ARMGLOBALS_PROTO_VOID);

/* gen.c */
extern void Gen(ARMGLOBALS_PROTO_VOID);
extern void GenCap(ARMGLOBALS_PROTO_VOID);
extern Boolean IsInCheck(ARMGLOBALS_PROTO UInt8 side);
extern Boolean IsInAttack(ARMGLOBALS_PROTO Int16 location, UInt8 side);
extern Int16 Repeat(ARMGLOBALS_PROTO_VOID);

/* util.c */
extern void SetStatus( FormPtr form, UInt16 fieldID, UInt16 id, ... );
extern Boolean CheckOSVersion(void);
extern void SetFldText( FormPtr form, UInt16 fieldID, Char *newStr );

/* setupform.c */
extern Boolean SetupHandleEvent(EventPtr event);

/* search.c */
extern void Think(ARMGLOBALS_PROTO_VOID);

/* eval.c */
extern Int16 Eval(ARMGLOBALS_PROTO_VOID);

/* levelform.c */
extern Boolean LevelHandleEvent(EventPtr event);


#endif

